// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];

var snridMBTemperature =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridCPU1Temperature =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0110;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;

var snridChassisIntrusion =    (parent.asID['ASWM_SNRTYPE_INTRUSION'] << 16) + 0x0120;

var compPower = new SysComponentInfo ('POWER', "parent.I18N['POWER']", 'info_power.jpg');

var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI)
    )
);

var compChassisFan = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.theSysInfo.quadrupleExtraAt(9)", "parent.once.theSysInfo.pairAt(9)"),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature).unit]", snridMBTemperature),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature)
    )
);
var compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
    new Tuple (
        new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
    )
);
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridFan2Speed]", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);

var compChassis = new SysComponentInfo ('CHASSIS', "parent.I18N['CHASSIS']", 'info_chassis.jpg',
    new Tuple (
        new triple ("parent.I18N['CHASSIS']", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridChassisIntrusion))", snridChassisIntrusion)
    ),
    new Tuple (
        new triple ('IALARM_CHASSISINTRUSION',
            new triple (new Point (0, 0), '"<img src=\\"" + parent.once.imgPath + "info_chassis_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridChassisIntrusion)
        )
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['LPT_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "1"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var theSystemComponents = new Tuple (
    compPower,
    compIOConnector,
    compChassis,
    compChassisFan,
    compMotherboard,
    compMemory,
    compPCI,
    compCPU1
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/ts100-e3_pi2/';
var theSystem = new SysModel ('model.jpg', chassis_tower);
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';
var imgPanelFront = 'main_front.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg' /*,
        new MapOfAreas (
            new AnArea (new Rect ( 29,  7,  88, 190), compChassis)
        ),
        new Tuple (
            new quadruple ('AL_CHASSIS', parent.asID['IDV_TYPE_SNR'], snridChassisIntrusion, new Point (46, 83))
        )*/
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 35,  19, 113,  73), compPower),
            new AnArea (new Rect ( 34,  84,  67, 146), compChassisFan),
            new AnArea (new Rect ( 69, 151, 121, 189), compPCI),
            new AnArea (new Rect (133,  81, 157, 156), compMemory),
            new AnArea (new Rect ( 86,  87, 123, 120), compCPU1),
            new AnArea (new Rect ( 55,  75, 172, 197), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_CHASSISFAN', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (41, 107)),
            new quadruple ('AL_CPUFAN1', parent.asID['IDV_TYPE_SNR'], snridFan2Speed, new Point (95, 95)),
            new quadruple ('AL_CPU1TEMP', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature, new Point (95, 95)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (95, 95)),
            new quadruple ('AL_MBTEMP', parent.asID['IDV_TYPE_SNR'], snridMBTemperature, new Point (104, 126))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas ( 
            new AnArea (new Rect ( 68,  25, 149,  76), compPower),
            new AnArea (new Rect ( 94,  92, 151, 150), compChassisFan),
            new AnArea (new Rect ( 67,  77,  90, 168), compIOConnector)
        ),
        new Tuple (
            new quadruple ('AL_CHASSISFAN', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (113, 113))
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('f',
        "parent.I18N['USB_PORT']", "4"
    ),

    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['LPT_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "1",
        "parent.I18N['USB_PORT']", "2"
    )
);

